function  [sts_mtrx]= check_if_point_belongs_to_object( varargin )
% check if given point (x,y,z) is a part of object. Margin is
% for computation accuracy (rounding object to mesh) usualy half of grid step in each coordinate.
% varargin{1} - object
% varargin{2} - vector with x y z coordinates
% varargin{3} - vector with z r alfa margins 
% output_args = 1 (true) if point belongs to object otherwise 0 (false)

   %             geometry.rmin= rmin_mm [milimeters] radius-inner part of element
   %             geometry.rmax= rmax_mm [milimeters] radius-outer part of element
   % 
   %             geometry.start_angle_deg= start_angle [degree] where object begins
   %             geometry.stop_angle_deg= stop_angle [degree] where object ends
   % 
   %             geometry.h_high= upper height of the element (z-axis)
   %             geometry.h_low
   
 this=varargin{1};
% vector_xyz=varargin{2};
% margin_zra=varargin{3};
xsq=varargin{2}; 
ysq=varargin{3}; 
zsq=varargin{4};
marginx=varargin{5};
marginy=varargin{5};
marginz=varargin{5};

%  geom=this.geometry;
% %    object_size=[geom.rmax,...
% %                 geom.rmin,...
% %                 geom.x_centre,...
% %                 geom.y_centre,...
% %                 geom.h_high,...
% %                 geom.h_low,...
% %                 geom.start_angle_deg,...
% %                 geom.stop_angle_deg];
%             
% onesz=ones(size(xsq));
% grx=onesz*geom.rmax;
% grn=onesz*geom.rmin;
% gxc=onesz*geom.x_centre;
% gyc=onesz*geom.y_centre;
% ghh=onesz*geom.h_high;
% ghl=onesz*geom.h_low;
% gsta=onesz*geom.start_angle_deg;
% gsto=onesz*geom.stop_angle_deg;
            
sts_mtrx = arrayfun(@(x,y,z,m,n,p) this.check_if_point_belongs_to_object_cuboid([x y z],[m n p]), xsq, ysq, zsq, marginx, marginy, marginz);
      

end

