function [h_plot]=sketch( varargin )
%SKETCH draw sketch of element 
% input 
% eGraphics Object
% or default without parameters

    CSE_obj=varargin{1};
    x=CSE_obj.geometry.cornerx;
    y=CSE_obj.geometry.cornery;
    z=CSE_obj.geometry.cornerz;

    xs=CSE_obj.geometry.sizex;
    ys=CSE_obj.geometry.sizey;
    zs=CSE_obj.geometry.sizez;

    vi=[x y z];
    %lenght in each direction
    %up from left down corner
    dxyz=[xs ys zs];        

if nargin==1
    
    % default
    gr=eGraphics(); 
    surface_color=gr.surface_color;
    edge_color=gr.edge_color;
    alpha=gr.alpha_v;
end   

if nargin==2
    
    if isa(varargin{2},'eGraphics')
        gr = varargin{2}; 
        
        surface_color=gr.surface_color;
        edge_color=gr.edge_color;
        alpha=gr.alpha_v;

    end

end

h_plot=voxel(vi, dxyz, surface_color, edge_color, alpha);

if nargin==1    
    % default
    gr.render_gcf();
end        
if nargin==2
                
    gr.render_gcf();
    
end

end

