function [h_plot]=sketch( varargin )
%SKETCH draw sketch of element 
% input 
% eGraphics Object
% or default without parameters

this=varargin{1};

if nargin==1
    
    % default
    gr=eGraphics(); 
    surface_color=gr.surface_color;
    edgecolor=gr.edge_color;
end   

if nargin==2
    
    if isa(varargin{2},'eGraphics')
        gr = varargin{2}; 
        
        surface_color=gr.surface_color;
        edgecolor=gr.edge_color;
        alpha=gr.alpha_v;
        alpha_edge=gr.alpha_edge;
    end

end

x1=this.sketch_data.x1;
y1=this.sketch_data.y1;
z1=this.sketch_data.z1;

x2=this.sketch_data.x2;
y2=this.sketch_data.y2;
z2=this.sketch_data.z2;

x3=this.sketch_data.x3;
y3=this.sketch_data.y3;
z3=this.sketch_data.z3;

x4=this.sketch_data.x4;
y4=this.sketch_data.y4;
z4=this.sketch_data.z4;

%edgecolor=edge_color;

hold on

surf(x1,y1,z1,'FaceColor',surface_color,'EdgeColor',edgecolor,'FaceAlpha',alpha,'EdgeAlpha',alpha_edge);

surf(x2,y2,z2,'FaceColor',surface_color,'EdgeColor',edgecolor,'FaceAlpha',alpha,'EdgeAlpha',alpha_edge);

surf(x3,y3,z3,'FaceColor',surface_color,'EdgeColor',edgecolor,'FaceAlpha',alpha,'EdgeAlpha',alpha_edge);

surf(x4,y4,z4,'FaceColor',surface_color,'EdgeColor',edgecolor,'FaceAlpha',alpha,'EdgeAlpha',alpha_edge);

xst=this.sketch_data.xst;
yst=this.sketch_data.yst;
zst=this.sketch_data.zst;

mesh(xst,yst,zst,'FaceColor',surface_color,'EdgeColor',edgecolor,'FaceAlpha',alpha_edge);


xsp=this.sketch_data.xsp;
ysp=this.sketch_data.ysp;
zsp=this.sketch_data.zsp;                
                
mesh(xsp,ysp,zsp,'FaceColor',surface_color,'EdgeColor',edgecolor,'FaceAlpha',alpha_edge);

hold off

%axis equal

if nargin==1    
    % default
    gr.render_gcf();
end        
if nargin==2
                
    gr.render_gcf();
    
end

h_plot=gcf;

end

