function potential_maps_out=potential_iterative_mex(varargin)
%function potential_maps=potential_iterative_mex(maxiter, deltammin)
% potential_iterative_mex - calculates potential distribution in 3D using
% mex file (compile C- language code)
%
% potential_maps = EF.potential_iterative(maxiter,deltamin)
%
% input:
%       maxiter=varargin{2};  number of max iteration of algorithm
%
%       deltamin=varargin{3};
%       e.g. 1e-14;  % almost the precision of double precision float e-16      
%
% the Ampere law in differential form -> finite difference formula
% Iterative algorithm
% apply finite difference formula for all voxels 
% and repeat this many steps until the potential distribution stabilizes
%

this=varargin{1};
maxiter=varargin{2};
deltamin=varargin{3};

permittivity=this.permittivity;
boundary=this.boundary;             % boundary values for each point list '-1' means potential must be compute

% invers index to matrix
iidx_neighbours=this.neighbours_iidx;

potential_maps=this.potential_maps; % map where computed values will be insert

%compute only in points with -1 values dont_compute in points with set
%values
where_make_computation=find(boundary==-1);

% iterative algorithm
% apply finite difference formula for all voxels 
% and repeat this many steps until the potential distribution stabilizes

% call mex file
%potential_maps_out=potential_iterative_c(maxiter,deltamin,potential_maps,permittivity,where_make_computation,iidx_neighbours);
potential_maps_out=potential_iterative_c(maxiter,deltamin,potential_maps,permittivity,boundary,iidx_neighbours);

this.potential_maps=potential_maps_out;


