function  show_potential(varargin)
% plots compute potential in given dimension
% input : 'row'
%         'col' 
%         'plane'
% or without input parameters (default is 'plane')
% e.g. EF.show_potential('plane');
% e.g. EF.show_potential('plane');
plot_number=0;
if nargin==1
    this=varargin{1};
    plot_mode='plane';
    X_plot=this.mesh.X_disp;
    Y_plot=this.mesh.Y_disp;
    Z_plot=this.mesh.Z_disp;
elseif nargin==2
    this=varargin{1};
    plot_number=varargin{2};
    plot_mode='plane';
    X_plot=this.mesh.X_disp;
    Y_plot=this.mesh.Y_disp;
    Z_plot=this.mesh.Z_disp;  
end

potential_maps = this.potential_maps;


[rows, cols]=size(potential_maps);

if plot_number>0
    cols=mod(plot_number,cols);
end

    for k=1:cols
    % for i=1:length(point_list)
    %     [r(i) c(i) p(i)]=ind2sub(mesh_size,point_list(i));
    % 
    %     pot_matrix(r(i),c(i),p(i))=potential_maps(i,k);
    % end

    % pot_matrix_3d
    pot_matrix_3d(:,:,:)=this.potential_maps_3d_matrix(k,:,:,:);
    size_el=size(pot_matrix_3d);

        if strcmp(plot_mode,'plane')
        %     for k=1:size_el(3)
        %         figure
        %         tmp=[];
        %         title plane
        %         tmp(:,:)=pot_matrix(:,:,k);
        %         imagesc(tmp)
        %         axis image;
        %         colormap('default');
        %         colorbar;
        %        
        %     end
        figure
            slice(X_plot,Y_plot,Z_plot,pot_matrix_3d,0,0,[max(max(max(Z_plot)))/4,max(max(max(Z_plot)))/2]);
        %     [x y z]=gradient(pot_matrix);
            grid on
            colormap(jet(256));
            colorbar('vertical');
            shading interp;
            view(30,30);
            xlabel('mm')
            ylabel('mm')
            zlabel('mm')
            title('Electric potential distribution [V]')
        end
    end

end

