function potential_maps=solve(varargin)
% input solcve method e.g.:
% EF.solve('iterative_mex',300,1e-14);  // for mex files and iterative
% algorithm
% EF.solve('iterative_mfile',300,1e-14); // for m-file iterative algorithm
%
% output potential maps

this=varargin{1};
solve_method=varargin{2};

if strcmp(solve_method,'iterative_mex')
    maxiter=varargin{3};
    deltamin=varargin{4};
    this.potential_iterative_mex(maxiter,deltamin);    
elseif strcmp(solve_method,'iterative_mfile')
    maxiter=varargin{3};
    deltamin=varargin{4};
    this.potential_iterative_mfile(maxiter,deltamin);  
elseif strcmp(solve_method,'algebraic')
    
end

potential_maps=this.potential_maps;
mesh_size=this.mesh.size_discrete_xyz;
mesh_voxel_size=size(this.mesh.X_disp);
point_list=this.point_list;

[row, col]=size(potential_maps);

number_of_electrodes=col;

%this.potential_maps_3d_matrix=zeros([number_of_electrodes mesh_voxel_size]);
this.potential_maps_3d_matrix=zeros([number_of_electrodes mesh_size]);

%pot_matrix_3d=zeros(mesh_voxel_size);
pot_matrix_3d=zeros(mesh_size);

%alloc memory
r=zeros(1,numel(point_list));
c=zeros(1,numel(point_list));
p=zeros(1,numel(point_list));

for k=1:number_of_electrodes
    for i=1:length(point_list)
        [r(i) c(i) p(i)]=ind2sub(mesh_size,point_list(i));

        pot_matrix_3d(r(i),c(i),p(i))=potential_maps(i,k);
    end

this.potential_maps_3d_matrix(k,:,:,:)=pot_matrix_3d(:,:,:);

end

