function S_map_of_pair=compute_S_electrode_pair(varargin)
%input: potential map first electrode
%       potential map second electrode
% return S (Sensotivity map) for set electrodes potential maps

this=varargin{1};
V1=varargin{2};
V2=varargin{3};
U=varargin{4};


% X_space=this.mesh.x_mm_centers.*1e3;
% Y_space=this.mesh.y_mm_centers.*1e3;
% Z_space=this.mesh.z_mm_centers.*1e3;
% 
% [Ex1 Ey1 Ez1] = gradient(V1,X_space,Y_space,Z_space);
% [Ex2 Ey2 Ez2] = gradient(V2,X_space,Y_space,Z_space);

sampling=this.mesh.sampling*1e-3;%in meters

% on border shouldn't be any gradient
V1(:,:,1)=V1(:,:,2);
V1(:,:,end)=V1(:,:,end-1);

V2(:,:,1)=V2(:,:,2);
V2(:,:,end)=V2(:,:,end-1);

[Ex1 Ey1 Ez1] = gradient(V1,sampling(1),sampling(2),sampling(3));
[Ex2 Ey2 Ez2] = gradient(V2,sampling(1),sampling(2),sampling(3));

% change from milimeters to meters
% Ex1=Ex1./1e3;
% Ey1=Ey1./1e3;
% Ez1=Ez1./1e3;
% 
% Ex2=Ex2./1e3;
% Ey2=Ey2./1e3;
% Ez2=Ez2./1e3;

% volume also in meters
%dV=(3sampling*1e-3)^3;

dV=sampling(1)*sampling(2)*sampling(3); %[m^3]

S_map_of_pair=-(1/U^2)*(Ex1.*Ex2+Ey1.*Ey2+Ez1.*Ez2).*dV;

% do zmiany
% na brzegu wyzerowa ujemne wartoci
% S_map_of_pair(:,:,1)=0;
% S_map_of_pair(:,:,end)=0;


