function S_map=compute_S_map(varargin)
% compute sensitivity maps
% output sensitivity maps (the same value is set in class object)
          
this=varargin{1};
potential_maps_3d_matrix=this.potential_maps_3d_matrix;

measurements_all=0;

sm = 1;

%%%
matrix_size=size(potential_maps_3d_matrix);

num_of_electrodes=matrix_size(1);
this.num_of_electrodes=num_of_electrodes;
single_sensitivity_map_size=matrix_size(2:end);

% number of electrode combination
num_of_sens_map=(num_of_electrodes*(num_of_electrodes-1))/2;

%alloc memory
this.S_map=zeros([num_of_sens_map single_sensitivity_map_size]);

num_combinations=num_of_electrodes/2;
num_combinations=ones(1,num_combinations);

[el_a_vect el_r_vect] = this.electrodes_pairs(num_of_electrodes);

this.el_a_vect=el_a_vect;
this.el_r_vect=el_r_vect;

display('compute S ensitivity');

for i=1:numel(el_a_vect)
        if mod(sm,20)==0
            sm
        end
        
        V1(:,:,:)=potential_maps_3d_matrix(el_a_vect(i),:,:,:);
        V2(:,:,:)=potential_maps_3d_matrix(el_r_vect(i),:,:,:);
        
        U1= min(min(min(V1)));  
        U2= max(max(max(V1)));
        
        U=abs(U1-U2);                
        
        this.S_map(sm,:,:,:)= this.compute_S_electrode_pair(V1,V2,U);  
        
        
        % sensitivity map should be the same for the same electrode pair
        % (angular distance in the circular ring)
        % when permittivity is static in FOV and sensor is symetric

        for m=1:(num_of_electrodes/2)
            % CW and CCW distance between electrodes
            if (el_r_vect(i)-el_a_vect(i)==m)||((el_a_vect(i)+num_of_electrodes-el_r_vect(i))==m)
                this.index_which_sensitivity_maps_to_correct{num_combinations(m),m}={[el_a_vect(i) el_r_vect(i) sm]};
                num_combinations(m)=num_combinations(m)+1;
                %in each column are values for the same electrode space
            end
        end
        sm = sm + 1;
    
end
    S_map=this.S_map;
    this.measurements_all=measurements_all;
    display('end compute S ensitivity');
end


% for el_a=1:num_of_electrodes
%     if measurements_all==0
%         num = num_of_electrodes;
%     else
%         num = el_a+num_of_electrodes-1;
%     end
%     for el_r=el_a+1:num
%         if el_r > num_of_electrodes
%             el_r = mod(el_r,num_of_electrodes);
%         end
%         
%         V1(:,:,:)=potential_maps_3d_matrix(el_a,:,:,:);
%         V2(:,:,:)=potential_maps_3d_matrix(el_r,:,:,:);
%         
%         U1= min(min(min(V1)));  
%         U2= max(max(max(V1)));
%         
%         U=abs(U1-U2);
%         
%         sm
%         
%         this.S_map(sm,:,:,:)= this.compute_S_electrode_pair(V1,V2,U);  
%         
%         
%         % sensitivity map should be the same for the same electrode pair
%         % (angular distance in the circular ring)
%         % when permittivity is static in FOV and sensor is symetric
% 
%         for m=1:(num_of_electrodes/2)
%             % CW and CCW distance between electrodes
%             if (el_r-el_a==m)||((el_a+num_of_electrodes-el_r)==m)
%                 this.index_which_sensitivity_maps_to_correct{num_combinations(m),m}={[el_a el_r sm]};
%                 num_combinations(m)=num_combinations(m)+1;
%                 %in each column are values for the same electrode space
%             end
%         end
%         sm = sm + 1;
%     end
% end
