function [ corr ] = geometric_correction(varargin)
% Geometrical correction of sensitivity maps. Electrodes with the same symetric length
% should have the same values 
% input: matrix with electrodes pair and sensitivity maps (constant electrode length in each column)
%      : sensitivity map
% output: corrected coefficient
this=varargin{1};
index_and_pair=varargin{2};
S_mtx=varargin{3};

[r c]=size(index_and_pair);
index_mtx=zeros([r c]);
for i=1:c
    for j=1:r
        tmp=cell2mat(index_and_pair{j,i});
        % get only index to sensitivity map row
        if ~isempty(tmp)
        index_mtx(j,i)=tmp(1,3);
        end
    end
end
% sum from rows
row_sum=sum(S_mtx,2);

    for m=1:c
      index=index_mtx(:,m);
      %index must be positive
      ind=index>0;
      index=index(ind);
      
      avg=mean(row_sum(index));
      for i=1:numel(index)
          %S_mtx(i,:)=S_mtx(i,:)*avg/row_sum(index(i));
%          S_mtx(index(i),:)=S_mtx(index(i),:)*avg/row_sum(index(i));
          corr(index(i)) = avg/row_sum(index(i));
      end
    end
corr=corr';
 %S_corrected=S_mtx';
    
end