function  plot_S_map( varargin )
% plot sensitivity maps
% input: 1) nth - plot all maps
%        2) number - plot number maps of sensitivity (if number is to high use
%        modulo) from beginning to given number
%        3) 3, 'single'  plot maps with given electrodes
% e.g plot_S_map();
%     plot_S_map(3);
%     plot_S_map(15,'single');

this=varargin{1};
num_of_map_to_plot=0;
single_mode='none';
if nargin==2
    num_of_map_to_plot=varargin{2};
elseif nargin==3
    num_of_map_to_plot=varargin{2};
    single_mode=varargin{3};
end

X_plot=this.mesh.X_disp;
Y_plot=this.mesh.Y_disp;
Z_plot=this.mesh.Z_disp;

if strcmp(single_mode,'none')
[maps,rows,cols,plane]=size(this.S_map);
if num_of_map_to_plot>0
    maps=mod(num_of_map_to_plot,maps);
end

for k=1:maps
% for i=1:length(point_list)
%     [r(i) c(i) p(i)]=ind2sub(mesh_size,point_list(i));
% 
%     pot_matrix(r(i),c(i),p(i))=potential_maps(i,k);
% end

% pot_matrix_3d
S_matrix_3d(:,:,:)=this.S_map(k,:,:,:);
size_el=size(S_matrix_3d);

%if strcmp(plot_mode,'plane')
%     for k=1:size_el(3)
%         figure
%         tmp=[];
%         title plane
%         tmp(:,:)=S_matrix(:,:,k);
%         imagesc(tmp)
%         axis image;
%         colormap('default');
%         colorbar;
%        
%     end
figure
z1=max(max(max(Z_plot)))/2; % center
z2=max(max(max(Z_plot)))/4;
z3=max(max(max(Z_plot)))*3/4;

    slice(X_plot,Y_plot,Z_plot,S_matrix_3d,0,0,[z1 z2 z3]);
%     [x y z]=gradient(pot_matrix);
    grid on
    colormap(jet(256));
    colorbar('vertical');
    shading interp;
    view(30,30);
    xlabel('mm')
    ylabel('mm')
    zlabel('mm')
    title('Sensitivity Matrix[m]')
%end
end
end

if strcmp(single_mode,'single')
el_a_vect=this.el_a_vect;
%el_r_vect=this.el_r_vect;
indx = find (el_a_vect==num_of_map_to_plot);

    for i=1:numel(indx)
    
        S_matrix_3d(:,:,:)=this.S_map(indx(i),:,:,:);
        size_el=size(S_matrix_3d);
        
        figure
        z1=max(max(max(Z_plot)))/2; % center
        z2=max(max(max(Z_plot)))/4;
        z3=max(max(max(Z_plot)))*3/4;
        slice(X_plot,Y_plot,Z_plot,S_matrix_3d,0,0,[z1 z2 z3]);
    %     [x y z]=gradient(pot_matrix);
        grid on
        colormap(jet(256));
        colorbar('vertical');
        shading interp;
        view(30,30);
        xlabel('mm')
        ylabel('mm')
        zlabel('mm')
        title('Sensitivity Matrix[m]')
    end
    
end
end

