classdef eGeometric_Primitive < handle
    
    %Geometry_Object Abstract class descirbes geometry element
    % e.g cube, cylinder etc.        
    
    properties (SetAccess='public')
        sketch_data % points which descibes only border points od element
        geometry    % struct. which describes object e.g. cylinder         
    end
    
    methods (Abstract=true, Access='public')
        
        % display sketch of the object, set eGraphics of the object
        % e.g. 
        sketch(varargin);     
        
        % check if given point (x,y,z) is a part of object. Margin is
        % for computation accuracy (rounding object to mesh) usualy half of grid step in each coordinate.
        [stts]= check_if_point_belongs_to_object( varargin )   
        
        % return bounding values xmin, xmax etc
        % [xmin xmax  ymin ymax  zmin zmax ]
        [bounding_box_xyz]=get_bounding_box(varargin)

        %return smallest object thick in each dimension (x, y, z)
        [xyz_thick]=get_smallest_thick(varargin)
        
    end % methods
    
end % class    


                

