function S_downscale=downscale_S(varargin)
% resize sensitivity to reconstruction size
% input S_3d matrix to rescale
% size to rescale

this=varargin{1};
mesh_voxel_size_upscale=this.mesh_voxel_size_upscale;
S_upscale=varargin{2};
mesh_invp=varargin{3};
mesh_big=this.FP_min.mesh;

sz=size(S_upscale);

num_of_maps=sz(1);

X=mesh_big.X_disp;
Y=mesh_big.Y_disp;
Z=mesh_big.Z_disp;
XI=mesh_invp.X_disp;
YI=mesh_invp.Y_disp;
ZI=mesh_invp.Z_disp;

this.mesh_invp=mesh_invp;

S_downscale=zeros([num_of_maps size(mesh_invp.X_disp)]);
if numel(sz)==4
for i=1:num_of_maps
    S_up(:,:,:)=S_upscale(i,:,:,:);
    % if size downscale is the same as forward problem model   
%     w=size_rescale==mesh_voxel_size_upscale;
%     res1=and(w(1),w(2));
%     res2=and(res1,w(3));
%     if res2
%         S_downscale(i,:,:)=S_up(:,:);
%     else
        VI = interp3(X,Y,Z,S_up,XI,YI,ZI,'linear',0); % if value is NaN put zero instead
        
        S_downscale(i,:,:,:) = VI(:,:,:);
    %S_downscale(i,:,:,:) = RESIZE(S_up,size_rescale);
   % end
end
elseif numel(sz)==3
for i=1:num_of_maps
    S_up(:,:)=S_upscale(i,:,:);
    
    % if size downscale is the same as forward problem model
    w=size_rescale==mesh_voxel_size_upscale(1:2);
    res=and(w(1),w(2));
    if res
        S_downscale(i,:,:)=S_up(:,:);
    else
        S_downscale(i,:,:)=imresize(S_up,size_rescale);
        %S_downscale(i,:,:) = RESIZE(S_up,size_rescale);   
    end
     
end
end

end