function [reshape_S_map_2d indicies_u S_matrix_2d]=sum_sensitivity_maps_to_2D(varargin)
% sum sesnitivity maps from 3d to 2d in specific volume
% input: point list of volume where maps will be sum
% sum_direction (r, c, p) e.g.
% LBP.sum_sensitivity_maps_to_2D(point_list_of_volume_where_sensitivity_is_intersesting,'p');
% sensitivity will be sume of two sets (where potential was computerd and user input)
% return [reshape_S_map_2d indicies_u S_matrix_2d]
% where indicies_u are indicies two 2d matrix (from where sensitivity was given after adding 3d matrix to two 2d matrix)

if nargin==4
this=varargin{1};
point_list_of_volume=varargin{2};
sum_direction=varargin{3};
S_map=varargin{4};

%  S_map=this.FP_phantom.S_map;
%  S_map_max=this.FP_max.S_map;
%  S_map_min=this.FP_min.S_map;

point_list_where_was_potential_computation=this.FP_min.point_list;

p=1;
for i=1:numel(point_list_of_volume)
    index=point_list_where_was_potential_computation==point_list_of_volume(i);
    
    if isempty(index)
        %do nth
    else
        sensitivity_sum_index(p)=point_list_of_volume(i);
        p=p+1;
    end
    
end


[maps,rows,cols,planes]=size(S_map);


for k=1:maps
    S_matrix_3d(:,:,:)=S_map(k,:,:,:);
    sensitivity_matrix=zeros(rows,cols,planes);
    
    sensitivity_matrix(sensitivity_sum_index(:))=S_matrix_3d(sensitivity_sum_index(:));
    
    if strcmp(sum_direction,'p')        
        sensitivity_matrix=sum(sensitivity_matrix,3,'double');
        
%         [r c p]=ind2sub(size(S_matrix_3d),sensitivity_sum_index);
%                 
%         a = find(p==floor(planes/2));
%         r_u = r(a);
%         c_u = c(a);
% %         % concatenating vectors
% %         indicies=cat(1,r,c);
% %         indicies=indicies';
% %         indicies_u=unique(indicies,'rows');
% %         r_u=indicies_u(:,1);
% %         c_u=indicies_u(:,2);
% %         
% %         tmp=zeros(1,numel(r_u));
% %         for j=1:numel(r_u)
% %             tmp(j)=sensitivity_matrix(r_u(j),c_u(j));
% %         end
%         
%           indicies_u=sub2ind(size(sensitivity_matrix),r_u,c_u);
%           indicies_u=sort(indicies_u);
%           %return unique and ascending order
%           %indicies_u=unique(indicies);
%         
%           % 2D sensitivity map -> row vector
%         sensitivity_matrix_only_selected_points=zeros(1,numel(indicies_u));
% %         for p=1:numel(indicies_u)

        indicies_u=this.linearind_3d_to_2d(size(S_matrix_3d),size(sensitivity_matrix),sensitivity_sum_index);

            sensitivity_matrix_only_selected_points=sensitivity_matrix(indicies_u);
%         end
        
    elseif strcmp(sum_direction,'r')
        sensitivity_matrix=sum(sensitivity_matrix,2,'double');
    elseif strcmp(sum_direction,'c')
        sensitivity_matrix=sum(sensitivity_matrix,1,'double');
    end
   
    S_matrix_2d(k,:,:)=sensitivity_matrix(:,:);
    
    reshape_S_map_2d(:,k)=sensitivity_matrix_only_selected_points(:);
end

this.sensitivity_sum_index=sensitivity_sum_index;

else
    error('Too many or less elements');
end

reshape_S_map_2d=reshape_S_map_2d';
end

