function [ permittivity ] = solve( varargin )
% Use to solve inverse problem. Linear Back Projection
% input max_permittivity_value
this=varargin{1};
% 2D or 3D
reconstruction_dimension=varargin{2};
min_perm_val=varargin{3};
max_perm_val=varargin{4};
S_matrix_2d=varargin{5};
indicies_2d=varargin{6};
S_map_2d=varargin{7};
point_list_from_where_get_sensitivity=varargin{8};
known_permittivity_point_list_3d=varargin{9};
known_permittivity_value=varargin{10};
% point_list_from_where_get_sensitivity=varargin{5};
% point_list_from_where_get_sensitivity=varargin{6};

C_pha=this.FP_phantom.C;
C_min=this.FP_min.C;
C_max=this.FP_max.C;

this.plot_min_max_measure_capacitance();

S_map_max=this.FP_max.S_map;
S_map_min=this.FP_min.S_map;
S_map_pha=this.FP_phantom.S_map;
S_max_reshape=this.FP_max.S_matrix;

if strcmp(reconstruction_dimension,'2D')
    % S_map_max=this.FP_max.S_map;

    %S_map_downscale_max=this.downscale_S(S_map_max,[30 30 10]);
    %S_map_max=S_map_downscale_max;
    % S_reshape_max=this.reshape_4d_to_2d(S_map_downscale_max);


    Cm_n=this.normalize_capacitance(C_pha,C_min,C_max);

    %%%pha
    % [reshape_S_map_2d S_matrix_2d]=this.sum_sensitivity_maps_to_2D(point_list_from_where_get_sensitivity,'p',S_map_pha);
    % 
    % S_sum=this.sum_s_map_to_one_map(reshape_S_map_2d);
    % 
    % s=sqrt(max(size(S_sum)));
    % 
    % this.plot_2d(S_sum,[s,s],'mesh');
    %%%

    %%%min
     [reshape_S_map_2d_pha S_matrix_2d_pha]=this.sum_sensitivity_maps_to_2D(point_list_from_where_get_sensitivity,'p',S_map_pha);
     
     S_matrix_3d(:,:,:)=S_map_pha(1,:,:,:);
     
     size_3d=size(S_matrix_3d);
     size_2d=[size_3d(1) size_3d(2)];
     known_permittivity_point_list_2d=this.linearind_3d_to_2d(size_3d,size_2d,known_permittivity_point_list_3d);
    % 
    % S_sum=this.sum_s_map_to_one_map(reshape_S_map_2d);
    % 
    % s=sqrt(max(size(S_sum)));
    % 
    % this.plot_2d(S_sum,[s,s],'mesh');


    %%%max
%     [S_matrix_2d indicies_2d S_map_2d]=this.sum_sensitivity_maps_to_2D(point_list_from_where_get_sensitivity,'p',S_map_max);

    % S_sum=this.sum_s_map_to_one_map(S_matrix_2d);
    % 
     % s=sqrt(max(size(S_sum)));
    % 
     % this.plot_2d(S_sum,[s,s],'mesh');
    %%%
    %downscale=this.mesh_voxel_size_downscale;

    %S_map_downscale_max=this.downscale_S(S_matrix_2d,downscale);
    %S_reshape_max=this.reshape_to_2d(S_map_downscale_max);

    %S_reshape_max=this.reshape_to_2d(S_matrix_2d);

    Sn=this.normalize_sensitivity(S_matrix_2d,'one');
    Sn_sum=this.sum_s_map_to_one_map(Sn);
    [m r c]=size(S_map_2d);
 
 plot_s=zeros(r,c);
 plot_s(indicies_2d)=Sn_sum;
 
 figure
 mesh(plot_s);
     % s=sqrt(max(size(Sn_sum)));
    % this.plot_2d(Sn_sum,[s,s],'mesh');

    %reconstruction
    %Cm_n=ones(size(Cm_n));
    permittivity = Sn'*Cm_n;
  
    permittivity=min_perm_val+permittivity.*(max_perm_val-min_perm_val);            
    
        
     [m r c]=size(S_map_2d);
 
    plot_p=zeros(r,c);
    plot_p(indicies_2d)=permittivity;
    plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
    
    permittivity=plot_p(indicies_2d);
    
    permittivity_real=permittivity*this.FP_phantom.vacuum_permittivity;
    
   
    C_r=reshape_S_map_2d_pha*permittivity_real';
    figure
    semilogy(C_r,'r')
    hold on
    semilogy(C_pha,'b')
    
    
%      [r c]=size(indicies_2d);
%      for i=1:r
%          plot_p(indicies_2d(i,1),indicies_2d(i,2))=permittivity(i);
%      end
     figure
     [m r c]=size(S_map_2d);
 
 plot_p=zeros(r,c);
 plot_p(indicies_2d)=permittivity;
 plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
     % plot_p=flipud(plot_p);
%      plot_p=plot_p';
     plot_p=flipud(plot_p);
     imagesc(plot_p);
    %point_list_from_where_get_sensitivity
    %voxel_size=this.FP_phantom.mesh.size_discrete_xyz;
    % voxel_size=[20 20];
    % [r,c,p]=size(S_matrix_2d);
    % permittivity=reshape(permittivity,[s s]);
    % for i=1:numel(point_list_from_where_get_sensitivity)
    %     [r c p]=ind2sub(voxel_size,point_list_from_where_get_sensitivity(i))
    %     permittivity_mtrx()=
    % end
elseif strcmp(reconstruction_dimension,'3D')
    % get only this points from sensitivity matrix which are importnat for
    % reconstruction
     S_map_max_selected_points  = this.get_from_maps_specific_points( point_list_from_where_get_sensitivity, S_map_max );
    
     rescale_dimensions=numel(this.mesh_voxel_size_upscale);
     if (rescale_dimensions~=3)
         error('Rescale value should be 3d vector')
     end
     % downscale size of maps
     S_map_downscale_max=this.downscale_S(S_map_max_selected_points,this.mesh_voxel_size_downscale);
   
      % debug plot
%      S_map_3d(:,:,:)=S_map_downscale_max(19,:,:,:);
%      [r c p]=size(S_map_3d);
%       [X, Y, Z] = meshgrid(1:r, 1:c, 1:p);
%     slice(X,Y,Z,S_map_3d,max(max(max(X)))/2,max(max(max(Y)))/2,max(max(max(Z)))/2);
% %   [x y z]=gradient(pot_matrix);
%     grid on
%     colormap(jet(256));
%     colorbar('vertical');
%     shading interp;
     
     S_mtrx_downscale=this.reshape_to_2d(S_map_downscale_max);
     %convert_map_to_mtrx(varargin)
     Sn=this.normalize_sensitivity(S_mtrx_downscale,'one');

    % debug -> values everywhere should be 1
    % Sn_sum=this.sum_s_map_to_one_map(Sn);
     

    Cm_n=this.normalize_capacitance(C_pha,C_min,C_max);

    permittivity = Sn'*Cm_n;
    permittivity=min_perm_val+permittivity.*(max_perm_val-min_perm_val);
    plot_perm=zeros(this.mesh_voxel_size_downscale);
    plot_perm(:)=permittivity(:);
    
    % debug_plot
    [r c p]=size(plot_perm);
    [X, Y, Z] = meshgrid(1:r, 1:c, 1:p);
    slice(X,Y,Z,plot_perm,max(max(max(X)))/2,max(max(max(Y)))/2,max(max(max(Z)))/2);
%   [x y z]=gradient(pot_matrix);
    grid on
    colormap(jet(16));
    colorbar('vertical');
    shading interp;

end % end recontruction dimension mode

end

