function [ permittivity ] = solve( varargin )
% Use to solve inverse problem. Linear Back Projection
% input max_permittivity_value
this=varargin{1};
% 2D or 3D
reconstruction_dimension=varargin{2};
min_perm_val=varargin{3};
max_perm_val=varargin{4};
S_matrix_2d_int=varargin{5};
indicies_2d_int=varargin{6};
S_map_2d_int=varargin{7};
point_list_from_where_get_sensitivity=varargin{8};
known_permittivity_point_list_3d=varargin{9};
known_permittivity_value=varargin{10};
% point_list_from_where_get_sensitivity=varargin{5};
% point_list_from_where_get_sensitivity=varargin{6};

C_pha=this.FP_phantom.C;
C_min=this.FP_min.C;
C_max=this.FP_max.C;

this.plot_min_max_measure_capacitance();

S_map_max=this.FP_max.S_map;
S_map_min=this.FP_min.S_map;
S_map_pha=this.FP_phantom.S_map;
S_max_reshape=this.FP_max.S_matrix;

if strcmp(reconstruction_dimension,'2D')    

    C_pha_n=this.normalize_capacitance(C_pha,C_min,C_max);

    %%%pha
%      [reshape_S_map_2d_pha S_matrix_2d_pha]=this.sum_sensitivity_maps_to_2D(point_list_from_where_get_sensitivity,'p',S_map_pha);
%      
%      S_matrix_3d(:,:,:)=S_map_pha(1,:,:,:);
%      
%      size_3d=size(S_matrix_3d);
%      size_2d=[size_3d(1) size_3d(2)];
%      known_permittivity_point_list_2d=this.linearind_3d_to_2d(size_3d,size_2d,known_permittivity_point_list_3d);
    perm_length=numel(indicies_2d_int);
 permittivity_estym = ones(perm_length,1).*(min_perm_val+max_perm_val)./2;
 permittivity_min = ones(perm_length,1).*min_perm_val;
 permittivity_max = ones(perm_length,1).*max_perm_val;
 
 %?
 C_prim_min=S_matrix_2d_int*permittivity_min;
 C_prim_max=S_matrix_2d_int*permittivity_max;
 
 C_prim_pha=C_pha_n.*(C_prim_max-C_prim_min)+C_prim_min;

 


    S_int_n=this.normalize_sensitivity(S_matrix_2d_int,'one');
    Sn_sum=this.sum_s_map_to_one_map(S_int_n);
    [m r c]=size(S_map_2d_int);
 
 plot_s=zeros(r,c);
 plot_s(indicies_2d_int)=Sn_sum;
 
 figure
 mesh(plot_s);
     % s=sqrt(max(size(Sn_sum)));
    % this.plot_2d(Sn_sum,[s,s],'mesh');

    %reconstruction
    %Cm_n=ones(size(Cm_n));
    permittivity = S_int_n'*C_pha_n;


    permittivity=min_perm_val+permittivity.*(max_perm_val-min_perm_val);            
    
    
    C_r=S_matrix_2d_int*permittivity;
    
    h_C=figure;
    hold on
    semilogy(C_prim_pha,'g');
    semilogy(C_prim_min,'b');
    semilogy(C_prim_max,'r');
    semilogy(C_r,'c');
    set(gca,'YScale','log');
    legend('measure_prim','min_prim','max_prim','C_r');
    set(gca,'YScale','log');
    hold off
    
    
%      [m r c]=size(S_map_2d);
%  
%     plot_p=zeros(r,c);
%     plot_p(indicies_2d)=permittivity;
%     plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
%     
%     permittivity=plot_p(indicies_2d);
%     
%     permittivity_real=permittivity*this.FP_phantom.vacuum_permittivity;
%     
%    
%     C_r=reshape_S_map_2d_pha*permittivity_real';
%     figure
%     semilogy(C_r,'r')
%     hold on
%     semilogy(C_pha,'b')
    
    
%      [r c]=size(indicies_2d);
%      for i=1:r
%          plot_p(indicies_2d(i,1),indicies_2d(i,2))=permittivity(i);
%      end
     figure
     [m r c]=size(S_map_2d_int);
 
 plot_p=zeros(r,c);
 plot_p(indicies_2d_int)=permittivity;
% plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
     % plot_p=flipud(plot_p);
%      plot_p=plot_p';
     plot_p=flipud(plot_p);
     imagesc(plot_p,[1, max(permittivity(:))]);
     
     x_thick_lab=this.mesh_invp.x_mm_centers;     
     
     xTicks = get(gca,['x' 'Tick']);
     mint=min(x_thick_lab);
     maxt=max(x_thick_lab);
     x_tick_val=linspace(mint,maxt,numel(xTicks));
     x_tick_val=round(x_tick_val);

     set(gca,'XTickLabel',x_tick_val);

     xlabel('[mm]')
     %y 
     y_thick_lab=this.mesh_invp.y_mm_centers;
     yTicks = get(gca,['y' 'Tick']);
     mint=min(y_thick_lab);
     maxt=max(y_thick_lab);
     y_tick_val=linspace(mint,maxt,numel(yTicks));
     y_tick_val=round(y_tick_val);
     set(gca,'YTickLabel',y_tick_val);
     ylabel('[mm]')

%      wynik=S_int_n'*ones(120,1);
%      figure
%      plot_p=zeros(r,c);
%  plot_p(indicies_2d_int)=wynik;
% % plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
%      % plot_p=flipud(plot_p);
% %      plot_p=plot_p';
%      plot_p=flipud(plot_p);
%      imagesc(plot_p);
     
elseif strcmp(reconstruction_dimension,'3D')
    
       C_pha_n=this.normalize_capacitance(C_pha,C_min,C_max);

    %%%pha
%      [reshape_S_map_2d_pha S_matrix_2d_pha]=this.sum_sensitivity_maps_to_2D(point_list_from_where_get_sensitivity,'p',S_map_pha);
%      
%      S_matrix_3d(:,:,:)=S_map_pha(1,:,:,:);
%      
%      size_3d=size(S_matrix_3d);
%      size_2d=[size_3d(1) size_3d(2)];
%      known_permittivity_point_list_2d=this.linearind_3d_to_2d(size_3d,size_2d,known_permittivity_point_list_3d);



 perm_length=numel(point_list_from_where_get_sensitivity);
 permittivity_estym = ones(perm_length,1).*(min_perm_val+max_perm_val)./2;
 permittivity_min = ones(perm_length,1).*min_perm_val;
 permittivity_max = ones(perm_length,1).*max_perm_val;
 
 %?
 C_prim_min=S_matrix_2d_int*permittivity_min;
 C_prim_max=S_matrix_2d_int*permittivity_max;
 
 C_prim_pha=C_pha_n.*(C_prim_max-C_prim_min)+C_prim_min;

 


    S_int_n=this.normalize_sensitivity(S_matrix_2d_int,'one');
%     Sn_sum=this.sum_s_map_to_one_map(S_int_n);
%     [m r c]=size(S_map_2d_int);
%  
%  plot_s=zeros(r,c);
%  plot_s(indicies_2d_int)=Sn_sum;
 
%  figure
%  mesh(plot_s);
     % s=sqrt(max(size(Sn_sum)));
    % this.plot_2d(Sn_sum,[s,s],'mesh');

    %reconstruction
    %Cm_n=ones(size(Cm_n));
    permittivity = S_int_n'*C_pha_n;


    permittivity=min_perm_val+permittivity.*(max_perm_val-min_perm_val);            
    
    
    C_r=S_matrix_2d_int*permittivity;
    
    h_C=figure;
    hold on
    semilogy(C_prim_pha,'g');
    semilogy(C_prim_min,'b');
    semilogy(C_prim_max,'r');
    semilogy(C_r,'c');
    set(gca,'YScale','log');
    legend('measure_prim','min_prim','max_prim','C_r');
    set(gca,'YScale','log');
    hold off
   
%      [m r c]=size(S_map_2d);
%  
%     plot_p=zeros(r,c);
%     plot_p(indicies_2d)=permittivity;
%     plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
%     
%     permittivity=plot_p(indicies_2d);
%     
%     permittivity_real=permittivity*this.FP_phantom.vacuum_permittivity;
%     
%    
%     C_r=reshape_S_map_2d_pha*permittivity_real';
%     figure
%     semilogy(C_r,'r')
%     hold on
%     semilogy(C_pha,'b')
    
    
%      [r c]=size(indicies_2d);
%      for i=1:r
%          plot_p(indicies_2d(i,1),indicies_2d(i,2))=permittivity(i);
%      end
     figure
     [m r c p]=size(S_map_2d_int);
 
 plot_p=zeros(r,c,p);
 plot_p(point_list_from_where_get_sensitivity(:))=permittivity(:);
% plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
     % plot_p=flipud(plot_p);
%      plot_p=plot_p';
     %plot_p=flipud(plot_p);
     
    
    % debug_plot
    %[r c p]=size(plot_p);
    %[X, Y, Z] = meshgrid(1:r, 1:c, 1:p);
    mesh_invp=this.mesh_invp;
    
    X=mesh_invp.X_disp;
    Y=mesh_invp.Y_disp;
    Z=mesh_invp.Z_disp;
    
    x_centres=mesh_invp.x_mm_centers;
    y_centres=mesh_invp.y_mm_centers;
    z_centres=mesh_invp.z_mm_centers;
    [r c p]=size(X);    
    
    z1=z_centres(round(p*1.5/4));
    z2=z_centres(round(p/2)); 
    z3=z_centres(round(p*3/4));
    
    slice(X,Y,Z,plot_p,x_centres(round(r/2)),y_centres(round(c/2)),[z1 z2 z3]);
%   [x y z]=gradient(pot_matrix);
    grid on
    colormap(jet(256));
    caxis([1, max(permittivity(:))]);
    colorbar('vertical');    
    shading interp;
     xlabel('[mm]');
    ylabel('[mm]');
    zlabel('[mm]');
    

end % end recontruction dimension mode

end

