function [ permittivity ] = solve( varargin )
% Use to solve inverse problem. Linear Back Projection
% input max_permittivity_value
this=varargin{1};
mode=varargin{2};
mode2=varargin{3};
min_perm_val=varargin{4};
max_perm_val=varargin{5};
numiter=varargin{6};
alpha_value=varargin{7};
S_matrix_2d_int=varargin{8};
indicies_2d_int=varargin{9};
S_map_2d_int=varargin{10};

C_pha=this.FP_phantom.C;
C_min=this.FP_min.C;
C_max=this.FP_max.C;
%C_avg=this.FP_avg.C;

permittivity_3d_matrix=this.FP_min.permittivity_3d_matrix;

this.plot_min_max_measure_capacitance();

S_map_max=this.FP_max.S_map;
S_map_min=this.FP_min.S_map;
S_map_pha=this.FP_phantom.S_map;
S_max_reshape=this.FP_max.S_matrix;


if strcmp(mode,'2D')
    
    if strcmp(mode2,'normal')
        C_pha_n=this.normalize_capacitance(C_pha,C_min,C_max);

        %%%pha
    %      [reshape_S_map_2d_pha S_matrix_2d_pha]=this.sum_sensitivity_maps_to_2D(point_list_from_where_get_sensitivity,'p',S_map_pha);
    %      
    %      S_matrix_3d(:,:,:)=S_map_pha(1,:,:,:);
    %      
    %      size_3d=size(S_matrix_3d);
    %      size_2d=[size_3d(1) size_3d(2)];
    %      known_permittivity_point_list_2d=this.linearind_3d_to_2d(size_3d,size_2d,known_permittivity_point_list_3d);
        perm_length=numel(indicies_2d_int);
     permittivity_estym = ones(perm_length,1).*(min_perm_val+max_perm_val)./2;
     permittivity_min = ones(perm_length,1).*min_perm_val;
     permittivity_max = ones(perm_length,1).*max_perm_val;

     %?
     C_prim_min=S_matrix_2d_int*permittivity_min;
     C_prim_max=S_matrix_2d_int*permittivity_max;

     C_prim_pha=C_pha_n.*(C_prim_max-C_prim_min)+C_prim_min;

        S_int_n=this.normalize_sensitivity(S_matrix_2d_int,'one');
        Sn_sum=this.sum_s_map_to_one_map(S_int_n);
        [m r c]=size(S_map_2d_int);

     plot_s=zeros(r,c);
     plot_s(indicies_2d_int)=Sn_sum;

     figure
     mesh(plot_s);
     % s=sqrt(max(size(Sn_sum)));
    % this.plot_2d(Sn_sum,[s,s],'mesh');

    %reconstruction
    %Cm_n=ones(size(Cm_n));
    % permittivity = Sn'*Cm_n;
    % permittivity=min_perm_val+permittivity.*(max_perm_val-min_perm_val);
    [r,c]=size(S_matrix_2d_int);
    permittivity=ones(c,1);
    %permittivity=permittivity*min_perm_val;
    
    

    C_r=S_matrix_2d_int*permittivity;
  

    figure(102);

    for i=1:numiter
        permittivity_=permittivity;
        %permittivity = this.alg_Landweber(S_matrix_2d,C_r,Cm,permittivity,alpha_value);
        permittivity = this.alg_Landweber(S_matrix_2d_int,C_r,C_prim_pha,permittivity,alpha_value);    


       % [m r c]=size(S_map_2d);

    %     plot_p=zeros(r,c);
    %     plot_p(indicies_2d)=permittivity;
    %     plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
    %     
    %     permittivity=plot_p(indicies_2d);
    %     permittivity=permittivity';
    %     figure(133)
    %     plot_p(indicies_2d)=permittivity;
    %     plot_p=flipud(plot_p);
    %     imagesc(plot_p);

          if mod(i,50)==0
            display 'iter';
            i
            figure(102); 
            %plot(C_r,'r'); 
            semilogy(C_r,'r');  
            hold on;
            %plot(C_pha);
            semilogy(C_prim_pha);
            drawnow
            hold off
          end

        % reprojection - current estimate of solution gives the measurements

        % remember previous value
        C_r_ = C_r;

        C_r = S_matrix_2d_int * permittivity;
        delta=permittivity_-permittivity;
        delta_c=C_r_ - C_r;
        delta_c(i)=(max(C_pha_n - C_r))^2; 
    end
    
    end
    
    if  strcmp(mode2,'normalize')
    
     C_pha_n=this.normalize_capacitance(C_pha,C_min,C_max);
     S_matrix_2d_int_n=this.normalize_sensitivity(S_matrix_2d_int,'one');

    [r,c]=size(S_matrix_2d_int);

    permittivity=zeros(c,1);
    
    C_r=S_matrix_2d_int_n*permittivity;
    
    figure(102);

    for i=1:numiter
        permittivity_=permittivity;
        
%         if i==1
%             alpha_value_=0.1
%         else
             alpha_value_=alpha_value;
%         end
        permittivity = this.alg_Landweber(S_matrix_2d_int_n,C_r,C_pha_n,permittivity,alpha_value_);    


       % [m r c]=size(S_map_2d);

    %     plot_p=zeros(r,c);
    %     plot_p(indicies_2d)=permittivity;
    %     plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
    %     
    %     permittivity=plot_p(indicies_2d);
    %     permittivity=permittivity';
    %     figure(133)
    %     plot_p(indicies_2d)=permittivity;
    %     plot_p=flipud(plot_p);
    %     imagesc(plot_p);

         if floor(mod(i,numiter/10))==0
            display 'iter';
            i
            figure(102); 
            %plot(C_r,'r'); 
            semilogy(C_r,'r');  
            hold on;
            %plot(C_pha);
            semilogy(C_pha_n);
            drawnow
            hold off
            
            
             figure(105)
            [m r c]=size(S_map_2d_int);

             plot_p=zeros(r,c);
             plot_p(indicies_2d_int)=permittivity;
             plot_p=flipud(plot_p);
            imagesc(plot_p,[min(permittivity(:)), max(permittivity(:))]);
            colorbar
            
          end

        % reprojection - current estimate of solution gives the measurements

        % remember previous value
        C_r_ = C_r;

        C_r = S_matrix_2d_int_n * permittivity;
        delta=permittivity_-permittivity;
        delta_c=C_r_ - C_r; 
        delta_c(i)=(max(C_pha_n - C_r))^2; 
     end
    end
    figure
    
    plot(delta_c);
    
    [m r c]=size(S_map_2d_int);
    permittivity=min_perm_val+permittivity.*(max_perm_val-min_perm_val);   
     plot_p=zeros(r,c);
     plot_p(indicies_2d_int)=permittivity;
     plot_p=flipud(plot_p);
    imagesc(plot_p,[1, max(permittivity(:))]);
    colorbar
     x_thick_lab=this.mesh_invp.x_mm_centers;     
     
     xTicks = get(gca,['x' 'Tick']);
     mint=min(x_thick_lab);
     maxt=max(x_thick_lab);
     x_tick_val=linspace(mint,maxt,numel(xTicks));
     x_tick_val=round(x_tick_val);

     set(gca,'XTickLabel',x_tick_val);

     xlabel('[mm]')
     %y 
     y_thick_lab=this.mesh_invp.y_mm_centers;
     yTicks = get(gca,['y' 'Tick']);
     mint=min(y_thick_lab);
     maxt=max(y_thick_lab);
     y_tick_val=linspace(mint,maxt,numel(yTicks));
     y_tick_val=round(y_tick_val);
     set(gca,'YTickLabel',y_tick_val);
     ylabel('[mm]')

    
end

if strcmp(mode,'3D')

    if strcmp(mode2,'normal')
         C_pha_n=this.normalize_capacitance(C_pha,C_min,C_max);

         perm_length=numel(indicies_2d_int);
         permittivity_estym = ones(perm_length,1).*(min_perm_val+max_perm_val)./2;
         permittivity_min = ones(perm_length,1).*min_perm_val;
         permittivity_max = ones(perm_length,1).*max_perm_val;

         %?
         C_prim_min=S_matrix_2d_int*permittivity_min;
         C_prim_max=S_matrix_2d_int*permittivity_max;

         C_prim_pha=C_pha_n.*(C_prim_max-C_prim_min)+C_prim_min;

        [r,c]=size(S_matrix_2d_int);

        permittivity=ones(c,1);
        C_r=S_matrix_2d_int*permittivity;

        figure(102);

    for i=1:numiter
        permittivity_=permittivity;

        permittivity = this.alg_Landweber(S_matrix_2d_int,C_r,C_prim_pha,permittivity,alpha_value);    


       % [m r c]=size(S_map_2d);

    %     plot_p=zeros(r,c);
    %     plot_p(indicies_2d)=permittivity;
    %     plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
    %     
    %     permittivity=plot_p(indicies_2d);
    %     permittivity=permittivity';
    %     figure(133)
    %     plot_p(indicies_2d)=permittivity;
    %     plot_p=flipud(plot_p);
    %     imagesc(plot_p);

         if mod(i,50)==0
            display 'iter';
            i
            figure(102); 
            %plot(C_r,'r'); 
            semilogy(C_r,'r');  
            hold on;
            %plot(C_pha);
            semilogy(C_prim_pha);
            drawnow
            hold off
          end

        % reprojection - current estimate of solution gives the measurements

        % remember previous value
        C_r_ = C_r;

        C_r = S_matrix_2d_int * permittivity;
        delta=permittivity_-permittivity;
        delta_c=C_r_ - C_r; 
          delta_c(i)=(max(C_pha_n - C_r))^2; 
    end
    end
    
if  strcmp(mode2,'normalize')
    
     C_pha_n=this.normalize_capacitance(C_pha,C_min,C_max);
     S_matrix_2d_int_n=this.normalize_sensitivity(S_matrix_2d_int,'one');

    [r,c]=size(S_matrix_2d_int);

    permittivity=zeros(c,1);
    
    C_r=S_matrix_2d_int_n*permittivity;
    
 

%     a=alpha_value;
% 
%     for k=0:numiter-1     
%        alpha_value(k+1)=a*1.2.^-k;
%     end
%     

delta_=0.1;
for i=1:numiter
    permittivity_=permittivity;
    
    
    
    permittivity = this.alg_Landweber(S_matrix_2d_int_n,C_r,C_pha_n,permittivity,alpha_value);    
            
    alpha_value_plot(i)=alpha_value;
   % [m r c]=size(S_map_2d);
 
%     plot_p=zeros(r,c);
%     plot_p(indicies_2d)=permittivity;
%     plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
%     
%     permittivity=plot_p(indicies_2d);
%     permittivity=permittivity';
%     figure(133)
%     plot_p(indicies_2d)=permittivity;
%     plot_p=flipud(plot_p);
%     imagesc(plot_p);

     if mod(i,50)==0
        display 'iter';
        i
        figure(102); 
        %plot(C_r,'r'); 
        semilogy(C_r,'r');  
        hold on;
        %plot(C_pha);
        semilogy(C_pha_n);
        drawnow
        hold off
      end
    
    % reprojection - current estimate of solution gives the measurements
    
    % remember previous value
    C_r_ = C_r;
    
    C_r = S_matrix_2d_int_n * permittivity;
    delta=abs((max(permittivity_-permittivity)));
%     if delta> delta_
%         alpha_value=alpha_value/4;
%         permittivity=permittivity_;       
%     else
%         delta_=delta;
%     end
        
    delta_c(i)=(max(C_pha_n - C_r))^2; 
end
    
end
figure
plot(delta_c);
title "deltaC";

figure
plot(alpha_value_plot)
title "alpha";

figure
     [m r c p]=size(S_map_2d_int);
 permittivity=min_perm_val+permittivity.*(max_perm_val-min_perm_val);   
 plot_p=zeros(r,c,p);
 plot_p(indicies_2d_int(:))=permittivity(:);
 %plot_p(point_list_delete_ring)=0;
% plot_p(known_permittivity_point_list_2d)=known_permittivity_value;
     % plot_p=flipud(plot_p);
%      plot_p=plot_p';
     %plot_p=flipud(plot_p);     

     mesh_invp=this.mesh_invp;
    
    X=mesh_invp.X_disp;
    Y=mesh_invp.Y_disp;
    Z=mesh_invp.Z_disp;
    
    x_centres=mesh_invp.x_mm_centers;
    y_centres=mesh_invp.y_mm_centers;
    z_centres=mesh_invp.z_mm_centers;
    [r c p]=size(X);    
    
    z1=z_centres(round(p*1.5/4));
    z2=z_centres(round(p/2)); 
    z3=z_centres(round(p*3/4));
    
    s=slice(X,Y,Z,plot_p,x_centres(round(r/2)),y_centres(round(c/2)),[z1 z2 z3]);
    grid on
    colormap(jet(256));  
    colorbar('vertical');    
    %shading interp;
    caxis([1, max(permittivity(:))]);
    alpha('color');
    set(s,'EdgeColor','none','FaceColor','interp',...
    'FaceAlpha','interp');
    
    % debug_plot
%     [r c p]=size(plot_p);
%     [X, Y, Z] = meshgrid(1:r, 1:c, 1:p);
%     
%     maxz=max(max(max(Z)));
%     minz=min(min(min(Z)));
%     
%     z=linspace(minz,maxz,20);
    % show only values from specific range
    ind=plot_p<=max(plot_p(:))*0.9965;
    plot_p(ind)=0;
    xlabel('[mm]');
    ylabel('[mm]');
    zlabel('[mm]');
    

figure
    s=slice(X,Y,Z,plot_p,max(max(max(X)))/2,max(max(max(Y)))/2,[z1 z2 z3]);%   [x y z]=gradient(pot_matrix);
    grid on
    colormap(jet(256));  
    colorbar('vertical');    
    %shading interp;
    caxis([1, max(permittivity(:))]);
    alpha('color');
    set(s,'EdgeColor','none','FaceColor','interp',...
    'FaceAlpha','interp');
    xlabel('[mm]');
    ylabel('[mm]');
    zlabel('[mm]');
    

figure
     data=smooth3(plot_p,'box',3);     
     %data=plot_p;
     p1 = patch(isosurface(data,0.2), ...
   'FaceColor','blue','EdgeColor','none');
     isonormals(data,p1);
     %axis vis3d tight
camlight; lighting phong


end


end

