function [pointlist point_list_and_vertices]=assign_mesh_points(varargin)
% set point list using given Mesh
% input Mesh
% output: point list and cubes with vertices
% this values are also set in eElement object automatically

this=varargin{1};
mesh=varargin{2};        

this.mesh=mesh;

A=this.get_bounding_box();
xmin=A(1);
xmax=A(2);
ymin=A(3); 
ymax=A(4); 
zmin=A(5); 
zmax=A(6);

mesh.set_size([xmin xmax ymin ymax zmin zmax]);

keySet = keys(this.all_elements.element_map);

display 'mesh'
display 'number of elements to mesh'
length(keySet)

%keySet=cell2mat(keySet);

valueSet = values(this.all_elements.element_map);

% update mesh
pointlists{1}=valueSet{1}.assign_mesh_points(mesh);            

% Perform the calculations, return updated objects
if length(valueSet)>=2
    parfor ii=2:length(valueSet)
        %for ii=2:length(valueSet)
        % each row pointlists(ii)= pointlist    point_list_and_vertices
        ii
        pointlists{ii}=valueSet{ii}.assign_mesh_points(mesh);            
    end
end


% update objects
parfor ii=1:length(valueSet)
     % values=pointlist    point_list_and_vertices
     point_list_values=pointlists{ii};
     
     % pointlist
     valueSet{ii}.point_list=point_list_values{1};
     % point_list_and_vertices
     valueSet{ii}.point_list_and_vertices=point_list_values{2};
end
 
% existingMapObj(newKeyName) = newValue;
% Put updated objects back into map
 for ii=1:length(keySet)     
     this.all_elements.element_map(keySet{ii}) = valueSet{ii};
 end
 
%update set senor with object with computed point lists 
 sensor_keys=this.sensor.element_map.keys;
% get from all meshed objects only sensor objects 
sensor_keys=cell2mat(sensor_keys);

for i=1:numel(sensor_keys)
    sensor_elements(i)=this.all_elements.element_map(sensor_keys(i));
    this.sensor.remove_element(sensor_keys(i),'id');
    this.sensor.add_element(sensor_elements(i));
end


% update phantom set
%update set phantom with object with computed point lists 
 phantom_keys=this.phantom.element_map.keys;
% get from all meshed objects only phantom objects 
phantom_keys=cell2mat(phantom_keys);

for i=1:numel(phantom_keys)
    phantom_elements(i)=this.all_elements.element_map(phantom_keys(i));
    this.phantom.remove_element(phantom_keys(i),'id');    
    this.phantom.add_element(phantom_elements(i));
end





% parfor i=1:length(keySet)
%  for i=1:length(keySet)
% %      display 'object is processing:' 
% %      i
% %      keySet(i)
% %      this.all_elements.element_map(keySet(i)).name
%      
%      this.all_elements.element_map(keySet(i)).assign_mesh_points(mesh);                
%      
% %     el=this.all_elements.element_map(keySet(i));
% %      el.mesh_view()
% 
% 
% %      display 'object is processing:' 
% % 
% %      this.all_elements.element_map(3).name
% %      
% %      this.all_elements.element_map(3).assign_mesh_points(mesh);                
% 
%  end

end

