classdef eSet < handle
    % Class describes set (group) of elements, which can descibes
    % e.g. sensor or phantom
    
    properties (SetAccess='public')        
        element_map         % map of elements  (id, Element)  
        name                % set name
        point_list          % point list which describes sum of elements point lists      
    end
    
    methods (Access='public')
        
        function this = eSet(varargin)
          if nargin > 0 ; % no input arguments
          if isa(varargin{1},'eSet')
            this = varargin{1}; % copy constructor
            display 'copy constructor eSet'
            return;                     
          else
               switch(nargin)
                   
                case 1,   
                
                if(strcmp(varargin{1},'wizard'))
                    
                    this.wizard(); %set eSet from input                    

                else
                    
                    this.name=varargin{1};
                    
                end   
                
                this.element_map = containers.Map('KeyType', 'double', 'ValueType', 'any');                
                
               otherwise,
                         error('Too less or too much input elements');
               end % switch
          end
          end
        
        end % constructor
        
        % add new Object of class Element to this Set
        add_element(varargin);
        
        % remove element with given 'id' or 'name'  e.g. eset_obj.remove_element(val,'id');
        remove_element(varargin);
        
        % sketch of all set elements
        sketch(none);        
        
        % get id of elements belongs to set with set name id=eset_obj.get_id(name)
        % name must be string or cell string array
        % id=eset_obj.get_id('rod') or id=eset_obj.get_id({'rod','electrode'})
        id=get_id(varargin);
        
        % get id of elements belongs to set with set id
        % name=eset_obj.get_name(id) 
        % id can be vector
        % return cell with names
        [ names ] = get_name(varargin)
           
        % return all set elements
        [Elements]=get_all(varargin)
        
        % Object elements
        % input: single string or cell with names e.g.
        % get_elements_by_name({'rod','electrode'})
        [Elements]=get_elements_by_name(varargin)
        
        % get linear indicies with given 'id' or 'name'  e.g. eset_obj.get_linear_indicies(val,'id');
        linear_ind=get_linear_indicies(varargin);
        
    end %methods
    
    methods (Access='private')
        
        function wizard(this)
                        
            in=input('Set name ', 's');

            if isempty(in)
                error('empty value')
            end
            
            this.name=in;
            
            % next val
                        
        end
    end
    
end

