function  [stts]= check_if_point_belongs_to_object( varargin )
% chech if given point (x,y,z) is a part of object. Margin is
% for computation accuracy (rounding object to mesh) usualy half of grid step in each coordinate.
% varargin{1} - object
% varargin{2} - vector with x y z coordinates
% varargin{3} - vector with z r z  margins 
% only r margin is use in this object
%
% output_args = 1 (true) if point belongs to object otherwise 0 (false)

%                 r=CE_obj.geometry.radius; 
%                 xc=CE_obj.geometry.x;
%                 yc=CE_obj.geometry.y;
%                 zc=CE_obj.geometry.z;

this=varargin{1};
vector_xyz=varargin{2};
margin_zra=varargin{3};

x=vector_xyz(1);
y=vector_xyz(2);
z=vector_xyz(3);


rm=margin_zra(2);


R=this.geometry.radius+rm;

xc=this.geometry.x;
yc=this.geometry.y;
zc=this.geometry.z;

if ((x-xc)^2 + (y-yc)^2 + (z-zc)^2 <= R^2)
   stts=1;
else 
    stts=0;
end

end

