classdef eSphere < eGeometric_Primitive
    %CYLINDRICAL_Object descirbes cylindrical element
    % constructor 
        % geometry.x=  % x coordinate of sphere center
        % geometry.y=  % y coordinate of sphere center
        % 
        % geometry.z=  % z coordinate of sphere center
        % geometry.radius= % radius of sphere
        %
        % geometry.accuracy= % accuracy of object
        
    
    properties (SetAccess='public')
        %sketch_data % points which descibes only border points od element
        %geometry
        % geometry.x=  % x coordinate of sphere center
        % geometry.y=  % y coordinate of sphere center
        % 
        % geometry.z=  % z coordinate of sphere center
        % geometry.radius= % radius of sphere
        % geometry.accuracy= % accuracy of object
    end
    
    methods (Access='public')
        
        function CE_obj = eSphere(varargin)
          if nargin > 0 ; % no input arguments
          if isa(varargin{1},'eSphere')
            CE_obj = varargin{1}; % copy constructor
            display 'Copy constructor eSphere'
            return;                     
          else
               switch(nargin)
                   
                case 1,   
                
                if(strcmp(varargin{1},'wizard'))
                    
                    CE_obj.wizard(); %set geometry from input

                else
                    
                    CE_obj.geometry=varargin{1};
                    
                end     
                
                r=CE_obj.geometry.radius; 
                xc=CE_obj.geometry.x;
                yc=CE_obj.geometry.y;
                zc=CE_obj.geometry.z;
                accuracy=CE_obj.geometry.accuracy;

                % sphere with radius r and center in (0,0,0)
                phi=linspace(0,pi,accuracy); 
                theta=linspace(0,2*pi,accuracy); 
                [phi,theta]=meshgrid(phi,theta); 

                x=r*sin(phi).*cos(theta); 
                y=r*sin(phi).*sin(theta); 
                z=r*cos(phi);
                
                %move sphere to given center point
                CE_obj.sketch_data.x=x+xc;
                CE_obj.sketch_data.y=y+yc;
                CE_obj.sketch_data.z=z+zc;
                
               otherwise,
                         error('Too less or too much input elements');
               end % switch
          end
          end
        
        end % constructor
    
        % SKETCH draw sketch of element 
        % input 
        % surface_color=[0.5 0.5 0.5];
        % edge_color=[1 1 1];
        % alpha=1;
        % or default without parameters
        % represents color of object. R,G,B must be in <0,1> range
        [ h_plot ] = sketch(varargin);        
        
        % chech if given point (x,y,z) is a part of object. Margin is
        % for computation accuracy (rounding object to mesh) usualy half of grid step in each coordinate.
        [stts]= check_if_point_belongs_to_object( varargin )
                
        %return smallest object thick in each dimension (x, y, z)
        [xthick ythick zthick]=get_smallest_thick(varargin)
        
        % return bounding values xmin, xmax etc
        % [xmin xmax  ymin ymax  zmin zmax ]
        [bounding_box_xyz]=get_bounding_box(varargin)

    end % methods
    
    methods (Access='private')
        
        function wizard(ec_obj)
            
            in=input('x coordinate of Sphere center [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.x=str2double(in);
            
            %next val
            
            in=input('y coordinate of Sphere center [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.y=str2double(in);
            
            %next val
            
            in=input('z coordinate of Sphere center [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.z=str2double(in);
            
            %next val
            in=input('Radius od Sphere [mm]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.radius=str2double(in);
            
            %next val
            in=input('Accuracy of sampling Sphere [number]: ', 's');

            if isempty(in)
                error('empty value')
            end
            
            ec_obj.geometry.accuracy=str2double(in);
            
        end
    end  
    
end % class    


                

