function model_params=create_phantom_3d(model_params)
display 'create phantom'

params_rod.axis_v='equal';    % e.g. equal
params_rod.view_a=[90,13];    % view=[0 75]
params_rod.light_a=[-12 30];   % light_a=[-45 30]
params_rod.ligt_type='phong'; % gouraud
params_rod.plot_h=gcf;    % plot handle
params_rod.alpha_v=0.5;   % transpaerncy
params_rod.alpha_edge=1;
params_rod.edge_color=[1 0 0]; %
params_rod.surface_color=[0.9 0 0]; %

gr_rod=eGraphics();
gr_rod.set_render_param(params_rod);

set_phantom=eSet('phantom');

% center_of_FOV_x = input('FOV center x [cartesian coordinates]: ');     
% center_of_FOV_y = input('FOV center y [cartesian coordinates]: ');     
% FOV_diameter    = input('FOV diameter [mm]: ');
% d = input('Circle rod diameter[mm]: ');
% D = input('D node (circle is in node) [mm]: ');
% eps_value = input('permittivity value for all rods [mm]: ');
% beta= input('Rotate phantom [degree]: ');
% rod_start_high = input('Rods Start High [mm]: ');
% rod_end_high = input('Rods end High [mm]: ');


% center_of_FOV_x = 0;     
% center_of_FOV_y = 0;     
% FOV_diameter    = 160;
% d = 30;
% D = 35;
% eps_value = 7;
% beta= 30;
% rod_start_high = 0;
% rod_end_high = 160;

center_of_FOV_x = 0;     
center_of_FOV_y = 0;     
FOV_diameter    = 160;
eps_value = 17;
beta= 0;
rod_start_high = 0;
rod_end_high = 180;
%rod_end_high = 115;

d = 20;
D = 22.1;
%index=[10 1 18 21 23 31]; % 6 pretw fov 160 20mm 22.1 mmm
%index=[9 27 25]; % 3 prety symetryczne duze odleglosci
%index=[27];
%index=[16,8,26,36,33,6,14];
%index=[10,31];
index=[7 29 5 25];
rod_end_high=[63 157 63 157];
rod_start_high=[23 117 23 117];

name='Pleksi';
name_p = {'perm'};
val=eps_value;
pleksi=eMaterial(name,name_p,val);

addpath('phantom_generator');
% 'wizard' or 'rods_indx'
[X,Y] = phantom_rod_list(center_of_FOV_x,center_of_FOV_y,FOV_diameter,d,D, beta, eps_value,'rods_indx',index);
%[X,Y] = phantom_rod_list(center_of_FOV_x,center_of_FOV_y,FOV_diameter,d,D, beta, eps_value,'wizard',index);


element_id=model_params.element_id;

for i=1:length(index)
    
    name='rod';
    element_id=element_id+1;
    rod=eElement(name,element_id);

    rod_voltage='none';

     geometry.rmin=0;
     geometry.rmax=d/2; %

     geometry.start_angle_deg=0;
     geometry.stop_angle_deg=360;

     geometry.h_high=rod_end_high(i);
     geometry.h_low=rod_start_high(i);

     geometry.x_centre=X(i); % center of a cylinder
     geometry.y_centre=Y(i);

     geometry.accuracy=30;

    rod_geom=eCylinder(geometry);
    rod.set_geometry_obj(rod_geom);
    rod.set_material_obj(pleksi);

    rod.set_graphics(gr_rod);

    set_phantom.add_element(rod);

    set_phantom.sketch();
    
   
end


%     name='Cuboid';
%     element_id=element_id+1;
%     cuboid=eElement(name,element_id);
%      
%     geometry.cornerx=-30;  % x corner of cuboid
%     geometry.cornery=-30;  % y corner of cuboid
%     geometry.cornerz=15;  % z corner of cuboid
%     
%     geometry.sizex=40;
%     geometry.sizey=40;
%     geometry.sizez=40;
% 
%     cg=eCuboid(geometry);
%     cuboid.set_geometry_obj(cg);
%     cuboid.set_material_obj(pleksi);
%     
%     cuboid.set_graphics(gr_rod);
% 
%     set_phantom.add_element(cuboid);
%     
%     
%     name='Cuboid2';
%     element_id=element_id+1;
%     cuboid=eElement(name,element_id);
%      
%     geometry.cornerx=-70;  % x corner of cuboid
%     geometry.cornery=-30;  % y corner of cuboid
%     geometry.cornerz=30;  % z corner of cuboid
%     
%     geometry.sizex=100;
%     geometry.sizey=40;
%     geometry.sizez=20;
% 
%     cg=eCuboid(geometry);
%     cuboid.set_geometry_obj(cg);
%     cuboid.set_material_obj(pleksi);
%     
%     cuboid.set_graphics(gr_rod);
% 
%     set_phantom.add_element(cuboid);
%     
%     
% 
%     set_phantom.sketch();

xlabel('[mm]');
ylabel('[mm]');
zlabel('[mm]');

assignin('base', 'pleksi', pleksi);
assignin('base', 'set_phantom', set_phantom);
model_params.set_phantom=set_phantom;
model_params.element_id=element_id;
