function model_params=create_sensor(model_params)

display 'create sensor'

params_electrode.axis_v='equal';    % e.g. equal
params_electrode.view_a=[90,13];    % view=[0 75]
params_electrode.light_a=[-12 30];   % light_a=[-45 30]
params_electrode.ligt_type='phong'; % gouraud
params_electrode.plot_h=gcf;    % plot handle
params_electrode.alpha_v=0.1;   % transpaerncy
params_electrode.alpha_edge=0;
params_electrode.edge_color=[0 0 0]; %
params_electrode.surface_color=[0.8 0 0]; %

gr_electrode=eGraphics();
gr_electrode.set_render_param(params_electrode);


% insulator between electrodes
insulator_between_el.axis_v='equal';    % e.g. equal
insulator_between_el.view_a=[90,13];    % view=[0 75]
insulator_between_el.light_a=[-12 30];   % light_a=[-45 30]
insulator_between_el.ligt_type='phong'; % gouraud
insulator_between_el.plot_h=gcf;    % plot handle
insulator_between_el.alpha_v=0.1;   % transpaerncy
insulator_between_el.alpha_edge=1;
insulator_between_el.edge_color=[0.6 0.6 0.7]; %
insulator_between_el.surface_color=[0 0 0.9]; %

gr_ins=eGraphics();
gr_ins.set_render_param(insulator_between_el);



% fov_radius      = input('FOV radius[mm]: ');                                   %[mm] diameter = 2*fov_radius
% ins1_thick      = input('Insulator between FOV and electrodes thick[mm]: ');   %[mm]
% electrode_thick = input('Electrode thick[mm]: ');                              %[mm]
% ins3_thick      = input('Insulator between electrode and screen thick[mm]: '); %[mm]
% screen_thick    = input('Screen thick[mm]: ');                                 %[mm]                     
% 
% number_of_electrodes         = input('Number of electrodes: ');         
% number_electrode_ring        = input('Number of electrode rings: ');
% ratio_electrode_to_insulator = input('Ratio electrode to insulator: ');
% start_ins2_angle             = input('Start insulator beetween electrodes angle: ');
% 
% fov_permittivity       = input('FOV  permittivity: ');;
% ins1_permittivity      = input('Insulator between FOV and electrodes permittivity: '); 
% electrode_permittivity = input('Electrodes Permittivity: ');
% ins2_permittivity      = input('Insulator between electrodes');
% ins3_permittivity      = input('Insulator between electrode and screen permittivity: ');
% screen_permittivity    = input('Screen permittivity: ');
% 
% electrode_potential    = input('Electrodes potential [V]: ');
% screen_potential    = input('Screen potential [V]: ');
% 
% electrode_high = input('Electrode high [mm]: ');                        
% sensor_high = input('Sensor high (must be more than Electrode high multiply by Number of electrode rings ): ');


%fov_radius      = 80;                                 %[mm] diameter = 2*fov_radius
fov_radius      = 80;
ins1_thick      = 5;   %[mm]
electrode_thick = 1;
ins3_thick      = 7;
screen_thick    = 1;

model_params.model_radius=fov_radius+ins1_thick+electrode_thick+ins3_thick+screen_thick;


number_of_electrodes         = 16;
number_electrode_ring        = 1;
ratio_electrode_to_insulator = 2;
start_ins2_angle             = [7.5 20];

fov_permittivity       = 1;
ins1_permittivity      = 3;
electrode_permittivity    = 10000;
ins2_permittivity      = 3;
ins3_permittivity      = 3;
screen_permittivity    = 10000;

electrode_potential    = 10;
model_params.electrode_potential=electrode_potential;
screen_potential       = 0;

electrode_high = 100;
model_params.electrode_high=electrode_high;
sensor_high = 115;
%sensor_high = 115;


electrode_start_z=sensor_high-electrode_high;
model_params.electrode_start_z=electrode_start_z/2;

name='Air';
name_p = {'perm'};
val=fov_permittivity;
air=eMaterial(name,name_p,val);

assignin('base', 'air', air);

name='insulator1';
name_p = {'perm'};
val=ins1_permittivity;
insulator1=eMaterial(name,name_p,val);
assignin('base', 'insulator1', insulator1);

name='insulator2';
name_p = {'perm'};
val=ins2_permittivity;
insulator2=eMaterial(name,name_p,val);
assignin('base', 'insulator2', insulator2);

name='insulator3';
name_p = {'perm'};
val=ins3_permittivity;
insulator3=eMaterial(name,name_p,val);
assignin('base', 'insulator3', insulator3);

name='Metal';
name_p = {'perm'};
val=electrode_permittivity;
metal1=eMaterial(name,name_p,val);
assignin('base', 'metal1', metal1);

name='Metal';
name_p = {'perm'};
val=screen_permittivity;
metal2=eMaterial(name,name_p,val);
assignin('base', 'metal2', metal2);

if(electrode_high*number_electrode_ring>sensor_high)
error('Sensor is not high enough')
end

set_sensor=eSet('sensor');


element_id=model_params.element_id;
% FOV

name='FOV';
element_id=element_id+1;
fov=eElement(name,element_id);

fov_potential='none';
   
fov_color.r=1; 
fov_color.g=0.9;
fov_color.b=1;       

fov_geometry.rmin=0;                        
fov_geometry.rmax=fov_radius;

fov_geometry.start_angle_deg=0;
fov_geometry.stop_angle_deg=360;

fov_geometry.h_high=sensor_high;
fov_geometry.h_low=0;

fov_geometry.x_centre=0; % center of a cylinder
fov_geometry.y_centre=0;
fov_geometry.accuracy=30;

fov_geom=eCylinder(fov_geometry);
fov.set_geometry_obj(fov_geom);
fov.set_material_obj(air);

model_params.fov=fov;

 set_sensor.add_element(fov);

% w=set_sensor.get_elements_by_name('FOV');
% 
% fov_set=eSet('fov');
% 
% fov_set.add_element(w);

% ins1 - insulator beetween FOV and electrodes
name='insulator beetween FOV and electrodes';
element_id=element_id+1;
ins1=eElement(name,element_id);

ins1_potential='none';
     
ins1_color.r=1; 
ins1_color.g=1;
ins1_color.b=0;      

ins1_color.r=1; 
ins1_color.g=1;
ins1_color.b=0;       

ins1_geometry.rmin=fov_radius;                        
ins1_geometry.rmax=fov_radius+ins1_thick;

ins1_geometry.start_angle_deg=0;
ins1_geometry.stop_angle_deg=360;

ins1_geometry.h_high=sensor_high;
ins1_geometry.h_low=0;

ins1_geometry.x_centre=0; % center of a cylinder
ins1_geometry.y_centre=0;
ins1_geometry.accuracy=30;

ins1_geom=eCylinder(ins1_geometry);

ins1.set_geometry_obj(ins1_geom);
ins1.set_material_obj(insulator1)
 
set_sensor.add_element(ins1);

model_params.ins1=ins1;

%  w=set_sensor.get_elements_by_name({'FOV','insulator beetween FOV and electrodes'});
% % 
%  test_set=eSet('fov');
% % 
% test_set.add_element(w);


space_between_electrode_rings_sum=sensor_high-number_electrode_ring*electrode_high;                                                

space_between_electrode_rings=space_between_electrode_rings_sum/(number_electrode_ring+1);

%sensor rings

for k=1:number_electrode_ring

% ins2- insulator beetween electrodes                         

number_of_insulator_beetween_electrodes=number_of_electrodes;                                                

% % Memory allocation
% Electrodes_vector=repmat(Cylinder_Sensor_Element,1,number_of_electrodes);
% Insulator2_vector=repmat(Cylinder_Sensor_Element,1,number_of_insulator_beetween_electrodes);

electrode_angle=360/(number_of_electrodes*(1+(1/ratio_electrode_to_insulator)));
insulator2_angle=360/(number_of_electrodes*(1+ratio_electrode_to_insulator));

for p=1:1:number_of_electrodes;

name='Insulator beetween electro';
element_id=element_id+1;
ins2=eElement(name,element_id);


ins2_color.r=1; 
ins2_color.g=1;
ins2_color.b=0;      

ins2_color.r=1; 
ins2_color.g=1;
ins2_color.b=0;       

ins2_geometry.rmin=ins1_geometry.rmax;                        
ins2_geometry.rmax=ins1_geometry.rmax+electrode_thick;

ins2_geometry.start_angle_deg = start_ins2_angle(k)+(p-1)*insulator2_angle+(p-1)*electrode_angle;
ins2_geometry.stop_angle_deg  = start_ins2_angle(k)+(p)*insulator2_angle+(p-1)*electrode_angle;

ins2_geometry.h_high=space_between_electrode_rings*k+electrode_high*k;
ins2_geometry.h_low=space_between_electrode_rings*k+electrode_high*(k-1);

ins2_geometry.x_centre=0; % center of a cylinder
ins2_geometry.y_centre=0;
ins2_geometry.accuracy=30;

ins2_geom=eCylinder(ins2_geometry);

ins2.set_geometry_obj(ins2_geom);    
ins2.set_material_obj(insulator2);

ins2.set_graphics(gr_ins);
set_sensor.add_element(ins2);

%****************************
% electrodes
name='electrode';
%element_id=element_id+p+k;
element_id=element_id+1;
electrode=eElement(name,element_id);

electrode_geometry.rmin=ins1_geometry.rmax;                        
electrode_geometry.rmax=ins1_geometry.rmax+electrode_thick;

electrode_geometry.start_angle_deg=start_ins2_angle(k)+(p)*insulator2_angle+(p-1)*electrode_angle;
electrode_geometry.stop_angle_deg=start_ins2_angle(k)+(p)*insulator2_angle+(p)*electrode_angle;

electrode_geometry.h_high=space_between_electrode_rings*k+electrode_high*k;
electrode_geometry.h_low=space_between_electrode_rings*k+electrode_high*(k-1);

electrode_geometry.x_centre=0; % center of a cylinder
electrode_geometry.y_centre=0;
electrode_geometry.accuracy=30;

electrode_geometry.x_centre=0; % center of a cylinder
electrode_geometry.y_centre=0;
electrode_geometry.accuracy=30;

ele_geom=eCylinder(electrode_geometry);

electrode.set_geometry_obj(ele_geom);    
electrode.set_material_obj(metal1);
electrode.set_boundary(electrode_potential)
electrode.set_graphics(gr_electrode);

set_sensor.add_element(electrode);

end

% insulator ring
name='Insulator beetween electro2';
element_id=element_id+1;
ins2=eElement(name,element_id);


ins2_geometry.rmin=ins1_geometry.rmax;                        
ins2_geometry.rmax=ins1_geometry.rmax+electrode_thick;

ins2_geometry.start_angle_deg = 0;
ins2_geometry.stop_angle_deg  = 360;

ins2_geometry.h_high=space_between_electrode_rings*k+electrode_high*(k-1);
ins2_geometry.h_low =space_between_electrode_rings*(k-1)+electrode_high*(k-1);

ins2_geometry.x_centre=0; % center of a cylinder
ins2_geometry.y_centre=0;
ins2_geometry.accuracy=30;

ins2_geom=eCylinder(ins2_geometry);

ins2.set_geometry_obj(ins2_geom);        
ins2.set_material_obj(insulator2);

set_sensor.add_element(ins2);

% add last ring
if k==number_electrode_ring
    name='Insulator beetween electro3';
    element_id=element_id+1;
    ins2=eElement(name,element_id);


    ins2_geometry.rmin=ins1_geometry.rmax;                        
    ins2_geometry.rmax=ins1_geometry.rmax+electrode_thick;

    ins2_geometry.start_angle_deg = 0;
    ins2_geometry.stop_angle_deg  = 360;

    ins2_geometry.h_high=space_between_electrode_rings*(k+1)+electrode_high*(k);
    ins2_geometry.h_low =space_between_electrode_rings*(k)+electrode_high*(k);

    ins2_geometry.x_centre=0; % center of a cylinder
    ins2_geometry.y_centre=0;
    ins2_geometry.accuracy=30;

    ins2_geom=eCylinder(ins2_geometry);

    ins2.set_geometry_obj(ins2_geom);       
    ins2.set_material_obj(insulator2);
    
    set_sensor.add_element(ins2);
end

end %electrode ring

% tmp_elem=set_sensor.get_elements_by_name('Insulator beetween electrodes');
% % % 
% set_ins2=eSet('Insulator beetween electrodes');
% % % 
% set_ins2.add_element(tmp_elem);
% 
% set_ins2.sketch();


% tmp_elem=set_sensor.get_elements_by_name('electrode');
% % % 
% set_ele=eSet('electrode');
% % % 
% set_ele.add_element(tmp_elem);
% 
% set_ele.sketch();

% insulator 3 (between electrodes and screen)

name='insulator between electro and screen';
element_id=element_id+1;
ins3=eElement(name,element_id);

ins3_geometry.rmin=electrode_geometry.rmax;                        
ins3_geometry.rmax=ins3_geometry.rmin+ins3_thick;

ins3_geometry.start_angle_deg=0;
ins3_geometry.stop_angle_deg=360;

ins3_geometry.h_high=sensor_high;
ins3_geometry.h_low=0;

ins3_geometry.x_centre=0; % center of a cylinder
ins3_geometry.y_centre=0;
ins3_geometry.accuracy=30;

ins3_geom=eCylinder(ins3_geometry);

ins3.set_geometry_obj(ins3_geom);        
ins3.set_material_obj(insulator3);

set_sensor.add_element(ins3);


% screen
name='screen';
element_id=element_id+1;
screen=eElement(name,element_id);

screen_geometry.rmin=ins3_geometry.rmax;                        
screen_geometry.rmax=screen_geometry.rmin+screen_thick;

screen_geometry.start_angle_deg=0;
screen_geometry.stop_angle_deg=360;

screen_geometry.h_high=sensor_high;
screen_geometry.h_low=0;

screen_geometry.x_centre=0; % center of a cylinder
screen_geometry.y_centre=0;
screen_geometry.accuracy=30;

screen_geom=eCylinder(screen_geometry);

screen.set_geometry_obj(screen_geom);        
screen.set_material_obj(metal2);
screen.set_boundary(screen_potential)

set_sensor.add_element(screen);
set_sensor.sketch()
%set_sensor.sketch()

xlabel('[mm]');
ylabel('[mm]');
zlabel('[mm]');

assignin('base', 'set_sensor', set_sensor);

model_params.set_sensor=set_sensor;
model_params.element_id=element_id;
